//+------------------------------------------------------------------+
//|                                    T3RSTL arrows alerts mtf.mq4  |
//| not for sale, rent, auction, nor lease                           |
//+------------------------------------------------------------------+
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//--------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrNONE
#property indicator_color2  clrNONE
#property indicator_color3  clrNONE
#property indicator_color4  clrNONE
#property indicator_color5  clrMaroon
#property indicator_color6  clrDarkGoldenrod
#property indicator_color7  clrNONE
#property indicator_width1  1
#property indicator_width3  1
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  1

//33 enPrices
enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen,     // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2, // Heiken ashi trend biased (extreme) price
   pr_habclose,   // Heiken ashi (better formula) close
   pr_habopen,    // Heiken ashi (better formula) open
   pr_habhigh,    // Heiken ashi (better formula) high
   pr_hablow,     // Heiken ashi (better formula) low
   pr_habmedian,  // Heiken ashi (better formula) median
   pr_habtypical, // Heiken ashi (better formula) typical
   pr_habweighted,// Heiken ashi (better formula) weighted
   pr_habaverage, // Heiken ashi (better formula) average
   pr_habmedianb, // Heiken ashi (better formula) median body
   pr_habtbiased, // Heiken ashi (better formula) trend biased price
   pr_habtbiased2 // Heiken ashi (better formula) trend biased (extreme) price
};

extern ENUM_TIMEFRAMES TimeFrame        = PERIOD_CURRENT;   // Time frame
extern int             T3Period         = 8;
extern double          T3Hot            = 0.7;
extern bool            T3Original       = false;
extern enPrices        Price            = pr_close;         // Price to use for T3RSTL calculation
extern bool            arrowsVisible    = false;             // Arrows visible?
extern bool            arrowsOnFirst    = false;            // Arrows shift?
extern string          arrowsIdentifier = "T3RSTLarrows";   // Unique ID for arrows
extern double          arrowsUpperGap   = 1.0;              // Upper arrow gap
extern double          arrowsLowerGap   = 1.0;              // Lower arrow gap
extern color           arrowsUpColor    = clrDarkGreen;   // Up arrow color
extern color           arrowsDnColor    = clrCrimson; // Down arrow color
extern int             arrowsUpCode     = 200;              // Up arrow code
extern int             arrowsDnCode     = 202;              // Down arrow code
extern bool            alertsOn         = false;            // Turn alerts on?
extern bool            alertsOnCurrent  = false;            // Alerts on still opened bar?
extern bool            alertsMessage    = false;             // Alerts should display message?
extern bool            alertsSound      = false;            // Alerts should play a sound?
extern bool            alertsNotify     = false;            // Alerts should send a notification?
extern bool            alertsEmail      = false;            // Alerts should send an email?
extern string          soundFile        = "alert2.wav";     // Sound file
extern bool            Interpolate      = true;             // Interpolate in multi time frame mode?

double T3RSTLhuu[],T3RSTLhud[],T3RSTLhdd[],T3RSTLhdu[],T3RSTL[],buffer2[],buffer3[],prices[],slope[],count[];
string indicatorFileName;
#define _mtfCall(_buff,_ind) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,T3Period,T3Hot,T3Original,Price,arrowsVisible,arrowsOnFirst,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,_buff,_ind)

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{ 
   IndicatorBuffers(10);
   SetIndexBuffer(0,T3RSTLhuu); SetIndexStyle(0, DRAW_LINE); SetIndexLabel(0, "T3RSTL uptrend line");
   SetIndexBuffer(1,T3RSTLhud); SetIndexStyle(1, DRAW_LINE); SetIndexLabel(1, "T3RSTL downtrend line");
   SetIndexBuffer(2,T3RSTLhdd); SetIndexStyle(2, DRAW_LINE); SetIndexLabel(2, "T3RSTL downtrend line");
   SetIndexBuffer(3,T3RSTLhdu); SetIndexStyle(3, DRAW_LINE); SetIndexLabel(3, "T3RSTL uptrend line");
   SetIndexBuffer(4,T3RSTL);
   SetIndexBuffer(5,buffer2); //uptrend line
   SetIndexBuffer(6,buffer3); //downtrend line
   SetIndexBuffer(7,prices); 
   SetIndexBuffer(8,slope); 
   SetIndexBuffer(9,count);
   
   indicatorFileName = WindowExpertName();
   TimeFrame         = fmax(TimeFrame,_Period);
    
    IndicatorShortName(timeFrameToString(TimeFrame)+" T3RSTL-Reference Slow");
return (0);
}
//+------------------------------------------------------------------+
int deinit()
{
   string lookFor       = timeFrameToString(TimeFrame)+" "+arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}
//+------------------------------------------------------------------+
//| T3RSTL                                                             |
//+------------------------------------------------------------------+
int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = fmin(Bars-counted_bars,Bars-1); count[0]=limit;
            if (TimeFrame!=_Period)
            {
               limit = (int)fmax(limit,fmin(Bars-1,_mtfCall(9,0)*TimeFrame/_Period));
               if (slope[limit]==-1) CleanPoint(limit,buffer2,buffer3);
               for (i=limit;i>=0 && !_StopFlag; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     T3RSTL [i]   = _mtfCall(4,y);
                     T3RSTLhuu[i] = EMPTY_VALUE;
                     T3RSTLhud[i] = EMPTY_VALUE;
                     T3RSTLhdd[i] = EMPTY_VALUE;
                     T3RSTLhdu[i] = EMPTY_VALUE;
                     buffer2[i]   = EMPTY_VALUE;
                     buffer3[i]   = EMPTY_VALUE;
                     slope[i]     = _mtfCall(8,y);
                     
                     //
                     //
                     //
                     //
                     //
                     
                      if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                      #define _interpolate(buff) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                      int n,k; datetime time = iTime(NULL,TimeFrame,y);
                         for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                         for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) _interpolate(T3RSTL);                                             
            }
            for(i=limit; i>=0; i--)
            {
               if (T3RSTL[i]>0)
               if (slope[i]==1)
                     T3RSTLhuu[i] = T3RSTL[i];
               else  T3RSTLhud[i] = T3RSTL[i];
               if (T3RSTL[i]<0)
               if (slope[i]==1)
                     T3RSTLhdu[i] = T3RSTL[i];
               else  T3RSTLhdd[i] = T3RSTL[i];
               if (slope[i]==-1) PlotPoint(i,buffer2,buffer3,T3RSTL);  
            }
   return(0);
   }

   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,buffer2,buffer3);
   for (i=limit; i >= 0; i--)
   {
     if (i<Bars-1)
     {
       prices[i] = getPrice(Price,Open,Close,High,Low,i,Bars);
       double value = 
-0.00514293*prices[i+0] 
-0.00398417*prices[i+1] 
-0.00262594*prices[i+2] 
-0.00107121*prices[i+3] 
+0.00066887*prices[i+4] 
+0.00258172*prices[i+5] 
+0.00465269*prices[i+6] 
+0.00686394*prices[i+7] 
+0.00919334*prices[i+8] 
+0.01161720*prices[i+9] 
+0.01411056*prices[i+10] 
+0.01664635*prices[i+11] 
+0.01919533*prices[i+12] 
+0.02172747*prices[i+13] 
+0.02421320*prices[i+14] 
+0.02662203*prices[i+15] 
+0.02892446*prices[i+16] 
+0.03109071*prices[i+17] 
+0.03309496*prices[i+18] 
+0.03490921*prices[i+19] 
+0.03651145*prices[i+20] 
+0.03788045*prices[i+21] 
+0.03899804*prices[i+22] 
+0.03984915*prices[i+23] 
+0.04042329*prices[i+24] 
+0.04071263*prices[i+25] 
+0.04071263*prices[i+26] 
+0.04042329*prices[i+27] 
+0.03984915*prices[i+28] 
+0.03899804*prices[i+29] 
+0.03788045*prices[i+30] 
+0.03651145*prices[i+31] 
+0.03490921*prices[i+32] 
+0.03309496*prices[i+33] 
+0.03109071*prices[i+34] 
+0.02892446*prices[i+35] 
+0.02662203*prices[i+36] 
+0.02421320*prices[i+37] 
+0.02172747*prices[i+38] 
+0.01919533*prices[i+39] 
+0.01664635*prices[i+40] 
+0.01411056*prices[i+41] 
+0.01161720*prices[i+42] 
+0.00919334*prices[i+43] 
+0.00686394*prices[i+44] 
+0.00465269*prices[i+45] 
+0.00258172*prices[i+46] 
+0.00066887*prices[i+47] 
-0.00107121*prices[i+48] 
-0.00262594*prices[i+49] 
-0.00398417*prices[i+50] 
-0.00514293*prices[i+51] 
-0.00609634*prices[i+52] 
-0.00684602*prices[i+53] 
-0.00739452*prices[i+54] 
-0.00774847*prices[i+55] 
-0.00791630*prices[i+56] 
-0.00790940*prices[i+57] 
-0.00774085*prices[i+58] 
-0.00742482*prices[i+59] 
-0.00697718*prices[i+60] 
-0.00641613*prices[i+61] 
-0.00576108*prices[i+62] 
-0.00502957*prices[i+63] 
-0.00423873*prices[i+64] 
-0.00340812*prices[i+65] 
-0.00255923*prices[i+66] 
-0.00170217*prices[i+67] 
-0.00085902*prices[i+68] 
-0.00004113*prices[i+69] 
+0.00073700*prices[i+70] 
+0.00146422*prices[i+71] 
+0.00213007*prices[i+72] 
+0.00272649*prices[i+73] 
+0.00324752*prices[i+74] 
+0.00368922*prices[i+75] 
+0.00405000*prices[i+76] 
+0.00433024*prices[i+77] 
+0.00453068*prices[i+78] 
+0.00465046*prices[i+79] 
+0.00469058*prices[i+80] 
+0.00466041*prices[i+81] 
+0.00457855*prices[i+82] 
+0.00442491*prices[i+83] 
+0.00423019*prices[i+84] 
+0.00399201*prices[i+85] 
+0.00372169*prices[i+86] 
+0.00342736*prices[i+87] 
+0.00311822*prices[i+88] 
+0.00280309*prices[i+89] 
+0.00249088*prices[i+90] 
+0.00219089*prices[i+91] 
+0.00191283*prices[i+92] 
+0.00166683*prices[i+93] 
+0.00146419*prices[i+94] 
+0.00131867*prices[i+95] 
+0.00124645*prices[i+96] 
+0.00126836*prices[i+97] 
-0.00401854*prices[i+98];  
       
       T3RSTL[i]    = iT3(value,T3Period,T3Hot,T3Original,i);      
       T3RSTLhuu[i] = EMPTY_VALUE;
       T3RSTLhud[i] = EMPTY_VALUE;
       T3RSTLhdd[i] = EMPTY_VALUE;
       T3RSTLhdu[i] = EMPTY_VALUE;
       buffer2[i]   = EMPTY_VALUE;
       buffer3[i]   = EMPTY_VALUE;
       slope[i]     = (i<Bars-1) ? (T3RSTL[i]>T3RSTL[i+1]) ? 1 : (T3RSTL[i]<T3RSTL[i+1]) ? -1 : slope[i+1] : 0;            
       if (T3RSTL[i]>0)
       if (slope[i]==1)
             T3RSTLhuu[i] = T3RSTL[i];
       else  T3RSTLhud[i] = T3RSTL[i];
       if (T3RSTL[i]<0)
       if (slope[i]==1)
             T3RSTLhdu[i] = T3RSTL[i];
       else  T3RSTLhdd[i] = T3RSTL[i];
       if (slope[i]==-1) PlotPoint(i,buffer2,buffer3,T3RSTL);
        
       //
       //
       //
       //
       //
       
       if (arrowsVisible)
       {
          string lookFor = timeFrameToString(TimeFrame)+" "+arrowsIdentifier+":"+(string)Time[i]; ObjectDelete(lookFor);            
             if (i<Bars-1 && slope[i] != slope[i+1])
             {
                if (slope[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
                if (slope[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
             } // if (i<Bars-1 && slope[i] != slope[i+1])
        } // if (arrowsVisible)
     }
   }
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] == 1) doAlert(" sloping up");
         if (slope[whichBar] ==-1) doAlert(" sloping down");       
      }         
   }   
return(0);
}
//------------------------------------------------------------------
#define _prHABF(_prtype) (_prtype>=pr_habclose && _prtype<=pr_habtbiased2)
#define _priceInstances     1
#define _priceInstancesSize 4
double workHa[][_priceInstances*_priceInstancesSize];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int bars, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars); instanceNo*=_priceInstancesSize; int r = bars-i-1;
         
         double haOpen  = (r>0) ? (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0 : (open[i]+close[i])/2;;
         double haClose = (open[i]+high[i]+low[i]+close[i]) / 4.0;
         if (_prHABF(tprice))
               if (high[i]!=low[i])
                     haClose = (open[i]+close[i])/2.0+(((close[i]-open[i])/(high[i]-low[i]))*MathAbs((close[i]-open[i])/2.0));
               else  haClose = (open[i]+close[i])/2.0; 
         double haHigh  = fmax(high[i], fmax(haOpen,haClose));
         double haLow   = fmin(low[i] , fmin(haOpen,haClose));
         
         if(haOpen<haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else               { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                              workHa[r][instanceNo+2] = haOpen;
                              workHa[r][instanceNo+3] = haClose;
         
         switch (tprice)
         {
            case pr_haclose:
            case pr_habclose:    return(haClose);
            case pr_haopen:   
            case pr_habopen:     return(haOpen);
            case pr_hahigh: 
            case pr_habhigh:     return(haHigh);
            case pr_halow:    
            case pr_hablow:      return(haLow);
            case pr_hamedian:
            case pr_habmedian:   return((haHigh+haLow)/2.0);
            case pr_hamedianb:
            case pr_habmedianb:  return((haOpen+haClose)/2.0);
            case pr_hatypical:
            case pr_habtypical:  return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:
            case pr_habweighted: return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:  
            case pr_habaverage:  return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
            case pr_habtbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
            case pr_habtbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }
   return(0);
}
//-------------------------------------------------------------------
void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}
//------------------------------------------------------------------
void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}
//------------------------------------------------------------------
void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," T3 RSTL ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" T3 RSTL ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
//-------------------------------------------------------------------
void drawArrow(int i,color theColor,int theCode,bool up)
{

   string name = timeFrameToString(TimeFrame)+" "+arrowsIdentifier+":"+(string)Time[i];
   double gap  = iATR(NULL,0,20,i);   

      int add = 0; if (!arrowsOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_ARROW,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}
//-------------------------------------------------------------------
string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
//-------------------------------------------------------------------
double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = forInstance*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}
//-------------------------------------------------------------------
